# Methods added to this helper will be available to all templates in the application.
module ApplicationHelper
  def gradient_text(text, color1 = '#FF4A00', color2 = '#0021A5')
    color1 = html_to_rgb(color1)
    color2 = html_to_rgb(color2)

    text = text.to_s
    res = ''
    ary = []; each_html_char(text) do |c| ary << c; end; ary
    for i in (0...ary.size)
      u = i.to_f / (ary.size-1).to_f
      color = (0...3).collect { |j| (color1[j]*(1-u) + color2[j]*u).round }
      res << "<span style='color:#{rgb_to_html(color)};'>#{ary[i]}</span>"
    end
    
    res
  end
  
private
  def html_char_end(str, index)
    return index if str[index] != ?&
    return index if !(i = str.index(?; , index))
    return index if str[index+1...i] !~ /^[A-Za-z]+$/
    return i
  end

  # Handle escaped HTML combinations (&something;) as single virtual characters
  def each_html_char(str)
    index = 0
    while index < str.length
      ch_end = html_char_end(str, index)
      yield str[index..ch_end]
      index = ch_end + 1
    end
  end

  def html_to_rgb(color)
    return [128, 128, 128] if color !~ /^#([0-9a-fA-F]{6})$/
    color = $1
    [ color[0..1].to_i(16), color[2..3].to_i(16), color[4..5].to_i(16) ]
  end

  def rgb_to_html(color)
    '#%02x%02x%02x' % color
  end
end
