require 'ioreader'

class Parser < IOReader
  # Initialize using a stream and have a line number
  def initialize(fin)
    super(fin)
  end
  
  # Reads in a keyword and its arguments, along with an optional size attribute
  def read_keyword(keyword, size_allowed, num_arguments, argument_error)
    min_args, max_args = nil
    if num_arguments.class == Array
      min_args, max_args = num_arguments
    else
      min_args = max_args = num_arguments
    end

    size = nil
    keyw = self.readline.rstrip
    raise IOError, "Expected keyword \"#{keyword}\" missing." if keyw == ''
    arguments = []
    if (max_args > 0)
      keyw, arguments = keyw.split(/\s+/, 2)
      arguments = arguments ? arguments.split(/\s+/, max_args) : []
    end
    keyw, size = keyw.split(':', 2) if size_allowed
    raise IOError, "Expected keyword \"#{keyword}\". Received \"#{keyw}\"." if keyw != keyword
    raise IOError, argument_error if min_args > arguments.size or arguments.size > max_args
    
    size_allowed ? [size, arguments] : arguments
  end
end